      double precision function map_steel_wkinetic
     &(nuc,t,g,rho,vm,sv)
      implicit none
      double precision nuc,t,g,rho,vm,sv
      double precision h,a,agsize,timc,s,sumve,x1,x0
      double precision dx,yb0,yb1,dinc,ve
      double precision map_steel_yb, map_steel_ybb
      double precision map_steel_wkinetic
      integer i1

* The term h is the height of the plate we don't know this so 
* let's use 1

      h=1.0d0


* The term a involves the radius of  curvature and plate height


      a=2.0d0*dsqrt(2.0d0*rho)*h

* Tc is the time to grow across a grain

      agsize=2.0d0/sv

      timc=agsize/g      


      s=a*nuc*dsqrt(g)*sv


      sumve=0.0

      do 10 i1=1,51

         x1=i1/51.0d0
         x0=(i1-1)/51.0d0 
         dx=x1-x0

         if (t .gt. timc ) then          
           yb1=map_steel_yb(s,t,timc,x1)   
           yb0=map_steel_yb(s,t,timc,x0) 
         else
           yb1=map_steel_ybb(s,t,timc,x1)   
           yb0=map_steel_ybb(s,t,timc,x0)
         endif

  

         dinc=0.5d0*(yb1+yb0)*dx

         sumve=sumve+dinc

10    continue

      if (t .le. timc) then
         ve=g*t*sumve*sv
      else
         ve=g*timc*sumve*sv
      endif

      if (ve/vm .gt. 173.0) then
         map_steel_wkinetic=vm
      else
         map_steel_wkinetic=vm*(1.0d0 - dexp(-ve/vm))
      endif
     
      end
